;---------------------------------------
; CopyCat Test Piece,  Version 1.0.0
; By: Paul Brennick

    .386                                ; Minimum requirement
    .model  flat, stdcall               ; 32 bit memory model
    option  casemap :none               ; Case sensitive

    include \GeneSys\include\Windows.inc
    include \GeneSys\macros\macros.asm
    uselib  user32,kernel32,shell32,gdi32,GeneSys

BaseToAscii     PROTO :DWORD, :DWORD, :DWORD
CopyCat         PROTO :DWORD, :DWORD, :DWORD
MakeBar         PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
MakeBox         PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
MakeButton      PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
MakeCheckBox    PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
MakeEditBox     PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
MakeFrame       PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
WinMain         PROTO :DWORD, :DWORD, :DWORD, :DWORD

.const
;---------------------------------------
IDM_MENU    equ 200
IDI_ICON1   equ 500
IDM_EXIT    equ 501
IDC_EXIT    equ 506

IDC_OK      equ 513
IDC_CANCEL  equ 514
IDC_EDT1    equ 519
IDC_STC1    equ 520
IDC_STC2    equ 521
IDC_STC3    equ 522
IDD_HELP    equ 523

.data
;---------------------------------------
ClassName   db  "CopyCatClass", 0
AppName     db  "  Testing The CopyCat Algorythm", 0
szString1   db  129 dup (0)
szString2   db  129 dup (0)
szDest      db  257 dup (0)
szCommand   db  256 dup (0)
ShowString  db  256 dup (?)

.data?
;---------------------------------------
hInstance   dd  ?
hIcon       dd  ?
hMenu       dd  ?
hWnd01      dd  ?
hWnd02      dd  ?
hWnd03      dd  ?
hWnd04      dd  ?
hWnd05      dd  ?
hWnd06      dd  ?
hWnd07      dd  ?
hWnd08      dd  ?
hWnd09      dd  ?
hWnd10      dd  ?
hWnd11      dd  ?
hWnd12      dd  ?
hWnd13      dd  ?
hWnd14      dd  ?
hWnd15      dd  ?
hWnd16      dd  ?
hWnd17      dd  ?
hWnd18      dd  ?
hWnd19      dd  ?
hFont1      dd  ?
hFont2      dd  ?
hResult     dd  ?

.code
start:
    invoke  GetModuleHandle, NULL       ; Get handle for this application
    mov     hInstance, eax              ; Save it for later usage
    invoke  WinMain, hInstance, NULL, NULL, SW_SHOWDEFAULT
    invoke  ExitProcess, eax

WinMain proc    hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
;---------------------------------------
    LOCAL   wc:WNDCLASSEX
    LOCAL   msg:MSG
    LOCAL   hwnd:HWND

    mov     wc.cbSize, SIZEOF WNDCLASSEX
    mov     wc.style, CS_HREDRAW or CS_VREDRAW
    mov     wc.lpfnWndProc, OFFSET WndProc
    mov     wc.cbClsExtra, NULL
    mov     wc.cbWndExtra, NULL
    push    hInst
    pop     wc.hInstance
    mov     wc.hbrBackground, COLOR_BTNFACE+1   ; COLOR_WINDOW+1
    mov     wc.lpszMenuName, IDM_MENU
    mov     wc.lpszClassName, OFFSET ClassName
    invoke  LoadIcon, hInst, IDI_ICON1
    mov     hIcon, eax
    mov     wc.hIcon, eax
    mov     wc.hIconSm, eax
    invoke  LoadCursor, NULL, IDC_ARROW
    mov     wc.hCursor, eax
    invoke  RegisterClassEx, addr wc
;   Center the Window
    invoke  GetSystemMetrics, SM_CXSCREEN   ; Get the Screen width
    sub     eax, 597                    ; Subtract the width of the main window
    shr     eax, 1                      ; Center the Game to the Desktop (Horizontal)
    push    eax                         ; Save the left position of the main window
    invoke  GetSystemMetrics, SM_CYSCREEN   ; Get the Screen height
    sub     eax, 400                    ; Subtract the height of the main window
    shr     eax, 1                      ; Center the Window to the Desktop (Vertical)
    pop     ebx
    invoke  CreateWindowEx, NULL, addr ClassName, addr AppName, WS_OVERLAPPED or \
            WS_MINIMIZEBOX or WS_SYSMENU, ebx, eax, 597, 400, NULL, NULL, hInst, NULL
    mov     hwnd, eax
    invoke  ShowWindow, hwnd, SW_SHOWNORMAL
    invoke  UpdateWindow, hwnd
;    invoke  GetMenu, hwnd
;    mov     hMenu, eax
StartLoop:
    invoke  GetMessage, addr msg, NULL, 0, 0
    cmp     eax, 0
    je      ExitLoop
;   Process keystrokes directly in the message loop
;   --------------------------------
    .if msg.message == WM_KEYDOWN
      .if msg.wParam==VK_F1             ; Helpful Information?
;        invoke  SendMessage, hwnd, WM_COMMAND, IDM_HELP, 0
        jmp     StartLoop
      .elseif msg.wParam==VK_TAB        ; Tab Key?
        invoke  GetFocus
        .if eax == hWnd02
          invoke  SetFocus, hWnd18
          jmp     StartLoop
        .elseif eax == hWnd18
          invoke  SetFocus, hWnd03
          jmp     StartLoop
        .elseif eax == hWnd03
          invoke  SetFocus, hWnd04
          invoke  SendMessage, hWnd04, EM_SETSEL, 0, -1
          jmp     StartLoop
        .elseif eax == hWnd04
          invoke  SetFocus, hWnd05
          invoke  SendMessage, hWnd05, EM_SETSEL, 0, -1
          jmp     StartLoop
        .elseif eax == hWnd05
          invoke  SetFocus, hWnd06
          invoke  SendMessage, hWnd06, EM_SETSEL, 0, -1
          jmp     StartLoop
        .elseif eax == hWnd06
          invoke  SetFocus, hWnd02
          jmp     StartLoop
        .endif
      .elseif msg.wParam==VK_RETURN     ; Enter key?
        invoke  GetFocus
        .if eax == hWnd02               ; Show Result Button?
          invoke  SendMessage, hwnd, WM_COMMAND, 401, 0
          jmp     StartLoop
        .elseif eax == hWnd03           ; Close Button?
          invoke  SendMessage, hwnd, WM_SYSCOMMAND, SC_CLOSE, NULL
          jmp     StartLoop
        .elseif eax == hWnd18           ; Reset Button?
          invoke  SendMessage, hwnd, WM_COMMAND, 403, 0
          jmp     StartLoop
        .endif
      .endif
    .endif
    .if msg.message == WM_KEYUP
      invoke  GetAsyncKeyState, VK_CONTROL
      rol     eax, 16
      cmp     ax, 1111111111111111b
      jne     ProcessMessage
      .if msg.wParam == 51h         ; Ctrl + Q
;        invoke  SendMessage, hwnd, WM_COMMAND, IDM_EXIT, 0
        jmp     StartLoop
      .endif
    .endif
ProcessMessage:
    invoke  TranslateMessage, addr msg
    invoke  DispatchMessage,  addr msg
    jmp     StartLoop
ExitLoop:
    mov     eax, msg.wParam
    ret
;---------------------------------------
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
    .if uMsg == WM_CREATE
      invoke  CreateFont, 24, 5, 0, 0, FW_LIGHT, FALSE, FALSE, FALSE, DEFAULT_CHARSET,\
              OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,\
              DEFAULT_QUALITY, DEFAULT_PITCH or FF_SCRIPT, chr$("MS Sans Serif")
      mov     hFont1, eax
      invoke  CreateFont, 18, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE, DEFAULT_CHARSET,\
              OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,\
              DEFAULT_QUALITY, DEFAULT_PITCH or FF_SCRIPT, chr$("MS Sans Serif")
      mov     hFont2, eax
      invoke  MakeBox, chr$("GeneSys CopyCat Testing Utility"), hWnd, 160, 2, 300, 36, 300
      mov     hWnd01, eax
      invoke  SendMessage, hWnd01, WM_SETFONT, hFont1, 1
      invoke  MakeBar, NULL, hWnd, 2, 40, 585, 1, 302  ; Heading Divider
      invoke  MakeBar, NULL, hWnd, 2, 324, 585, 1, 303 ; Bottom Divider
      invoke  MakeButton, chr$("Show Result"), hWnd, 160, 336, 100, 24, 401
      mov     hWnd02, eax
      invoke  MakeButton, chr$("Close"), hWnd, 350, 336, 70, 24, 402
      mov     hWnd03, eax
      invoke  MakeButton, chr$("Reset"), hWnd, 270, 336, 70, 24, 403
      mov     hWnd18, eax
      invoke  SendMessage, hWnd02, WM_SETFONT, hFont2, 1
      invoke  SendMessage, hWnd03, WM_SETFONT, hFont2, 1
      invoke  MakeEditBox, NULL, hWnd, 20, 80, 270, 24, 304
      mov     hWnd04, eax
      invoke  MakeEditBox, NULL, hWnd, 300, 80, 270, 24, 305
      mov     hWnd05, eax
      invoke  MakeEditBox, NULL, hWnd, 20, 140, 550, 24, 306
      mov     hWnd06, eax
      invoke  SendMessage, hWnd04, EM_LIMITTEXT, 128, 0
      invoke  SendMessage, hWnd05, EM_LIMITTEXT, 128, 0
      invoke  SendMessage, hWnd06, EM_LIMITTEXT, 256, 0
      invoke  MakeBox, chr$("Source One (128 Bytes max.):"), hWnd, 20, 55, 200, 24, 307
      mov     hWnd11, eax
      invoke  MakeBox, chr$("Source Two (128 Bytes max.):"), hWnd, 300, 55, 200, 24, 308
      mov     hWnd12, eax
      invoke  MakeBox, chr$("Destination (256 Bytes max.):"), hWnd, 20, 115, 200, 24, 309
      mov     hWnd13, eax
      invoke  MakeBox, chr$("Select Mode:"), hWnd, 20, 175, 80, 24, 315
      mov     hWnd14, eax
      invoke  MakeFrame, NULL, hWnd, 20, 200, 550, 30, 314
      invoke  MakeCheckBox, chr$(" Copy "), hWnd, 53, 204, 80, 24, 310
      mov     hWnd07, eax
      invoke  MakeCheckBox, chr$(" Concatenate "), hWnd, 139, 204, 100, 24, 311
      mov     hWnd08, eax
      invoke  MakeCheckBox, chr$(" Do Both "), hWnd, 270, 204, 80, 24, 312
      mov     hWnd09, eax
      invoke  MakeCheckBox, chr$(" Get Length of String Only "), hWnd, 371, 204, 180, 24, 313
      mov     hWnd10, eax
      invoke  SendMessage, hWnd04, WM_SETFONT, hFont2, 1
      invoke  SendMessage, hWnd05, WM_SETFONT, hFont2, 1
      invoke  SendMessage, hWnd06, WM_SETFONT, hFont2, 1
      invoke  SendMessage, hWnd07, WM_SETFONT, hFont2, 1
      invoke  SendMessage, hWnd08, WM_SETFONT, hFont2, 1
      invoke  SendMessage, hWnd09, WM_SETFONT, hFont2, 1
      invoke  SendMessage, hWnd10, WM_SETFONT, hFont2, 1
      invoke  SendMessage, hWnd11, WM_SETFONT, hFont2, 1
      invoke  SendMessage, hWnd12, WM_SETFONT, hFont2, 1
      invoke  SendMessage, hWnd13, WM_SETFONT, hFont2, 1
      invoke  SendMessage, hWnd14, WM_SETFONT, hFont2, 1
      invoke  SendMessage, hWnd18, WM_SETFONT, hFont2, 1
      invoke  MakeFrame, NULL, hWnd, 20, 270, 400, 30, 316
      invoke  MakeFrame, NULL, hWnd, 430, 270, 140, 30, 319
      invoke  MakeBox, chr$("The Source Code That Will Be Used:"), hWnd, 20, 245, 280, 24, 317
      mov     hWnd15, eax
      invoke  MakeBox, chr$("Length of Destination:"), hWnd, 430, 245, 140, 24, 320
      mov     hWnd17, eax
      invoke  MakeBox, NULL, hWnd, 30, 274, 360, 24, 318
      mov     hWnd16, eax
      invoke  MakeBox, NULL, hWnd, 440, 274, 100, 24, 319
      mov     hWnd19, eax
      invoke  SendMessage, hWnd15, WM_SETFONT, hFont2, 1
      invoke  SendMessage, hWnd16, WM_SETFONT, hFont2, 1
      invoke  SendMessage, hWnd17, WM_SETFONT, hFont2, 1
      invoke  SendMessage, hWnd19, WM_SETFONT, hFont2, 1
      jmp     begin
    .elseif uMsg==WM_COMMAND
      mov     eax, wParam               ; Get message
      mov     edx, eax                  ; Store it in the data register
      shr     edx, 16                   ; Preserve only the LSWord
      and     eax, 0FFFFh               ; Mask out the unused portions
      .if edx==BN_CLICKED               ; If a button was clicked ...
        .if eax == 402                  ; If it is the 'Close' button
          invoke  SendMessage, hWnd, WM_SYSCOMMAND, SC_CLOSE, NULL
        .elseif eax == 403              ; If it is the 'Reset' Button
begin:    mov     hResult, 310              ; MODE = Copy
          invoke  SendMessage, hWnd07, BM_SETCHECK, BST_CHECKED, 0
          invoke  SendMessage, hWnd08, BM_SETCHECK, BST_UNCHECKED, 0
          invoke  SendMessage, hWnd09, BM_SETCHECK, BST_UNCHECKED, 0
          invoke  SendMessage, hWnd10, BM_SETCHECK, BST_UNCHECKED, 0
          invoke  SendMessage, hWnd04, EM_SETREADONLY, FALSE, 0
          invoke  SendMessage, hWnd05, WM_SETTEXT, 0, chr$("NULL")
          invoke  CopyCat, addr szString1,
                  chr$("The Quick Brown Fox Jumped Over The Lazy Dog."), NULL
          invoke  SendMessage, hWnd04, WM_SETTEXT, 0, addr szString1
          invoke  SendMessage, hWnd05, EM_SETREADONLY, TRUE, 0
          invoke  CopyCat, addr szDest,
                  chr$("The text in Source One will replace any text already here."), NULL
          invoke  SendMessage, hWnd06, WM_SETTEXT, 0, addr szDest
          invoke  SendMessage, hWnd06, EM_SETREADONLY, TRUE, 0
          invoke  CopyCat, addr szCommand,
                  chr$("invoke  CopyCat, addr szResult, addr szString1, NULL"), NULL
          invoke  SendMessage, hWnd16, WM_SETTEXT, 0, addr szCommand
          invoke  SetFocus, hWnd04
          invoke  SendMessage, hWnd04, EM_SETSEL, 0, -1
          ret
        .elseif eax == 401              ; If it is the 'Show Result' button
          invoke  SendMessage, hWnd04, WM_GETTEXT, 128, addr szString1
          invoke  SendMessage, hWnd05, WM_GETTEXT, 128, addr szString2
          invoke  SendMessage, hWnd06, WM_GETTEXT, 256, addr szDest
          .if hResult == 310
            invoke  CopyCat, addr szDest, addr szString1, NULL
          .elseif hResult == 311
            invoke  CopyCat, addr szDest, NULL, addr szString2
          .elseif hResult == 312
            invoke  CopyCat, addr szDest, addr szString1, addr szString2
          .elseif hResult == 313
            invoke  CopyCat, addr szDest, NULL, NULL
          .else
            ret
          .endif
;         Do the following while EAX is valid, then do the rest.
          invoke  BaseToAscii, eax, addr ShowString, 0
          invoke  SendMessage, hWnd19, WM_SETTEXT, 0, addr ShowString
          invoke  SendMessage, hWnd06, WM_SETTEXT, 0, addr szDest
          ret
        .elseif eax == 310              ; First Radio Button in Group
          mov     hResult, 310          ; MODE = Copy
          invoke  SendMessage, hWnd04, EM_SETREADONLY, FALSE, 0
          invoke  SendMessage, hWnd05, EM_SETREADONLY, TRUE, 0
          invoke  SendMessage, hWnd06, EM_SETREADONLY, TRUE, 0
          invoke  CopyCat, addr szDest,
                  chr$("The text in Source One will be replace any text already here."), NULL
          invoke  SendMessage, hWnd06, WM_SETTEXT, 0, addr szDest
          invoke  CopyCat, addr szCommand,
                  chr$("invoke  CopyCat, addr szResult, addr szString1, NULL"), NULL
          invoke  SendMessage, hWnd16, WM_SETTEXT, 0, addr szCommand
          invoke  SetFocus, hWnd04
        .elseif eax == 311              ; Second Radio Button
          mov     hResult, 311          ; MODE = Concatenate
          invoke  SendMessage, hWnd05, EM_SETREADONLY, FALSE, 0
          invoke  SendMessage, hWnd04, EM_SETREADONLY, TRUE, 0
          invoke  SendMessage, hWnd06, EM_SETREADONLY, FALSE, 0
          invoke  CopyCat, addr szDest,
                  chr$("The text in Source Two will be added to any text already here."), NULL
          invoke  SendMessage, hWnd06, WM_SETTEXT, 0, addr szDest
          invoke  CopyCat, addr szCommand,
                  chr$("invoke  CopyCat, addr szResult, NULL, addr szString2"), NULL
          invoke  SendMessage, hWnd16, WM_SETTEXT, 0, addr szCommand
          invoke  SetFocus, hWnd05
        .elseif eax == 312              ; Third Radio Button
          mov     hResult, 312          ; MODE = Copy & Concatenate
          invoke  SendMessage, hWnd04, EM_SETREADONLY, FALSE, 0
          invoke  SendMessage, hWnd05, EM_SETREADONLY, FALSE, 0
          invoke  SendMessage, hWnd06, EM_SETREADONLY, TRUE, 0
          invoke  CopyCat, addr szDest,
                  chr$("The text in Source One and Source Two will replace any text already here."), NULL
          invoke  SendMessage, hWnd06, WM_SETTEXT, 0, addr szDest
          invoke  CopyCat, addr szCommand,
                  chr$("invoke  CopyCat, addr szResult, addr szString1, addr szString2"), NULL
          invoke  SendMessage, hWnd16, WM_SETTEXT, 0, addr szCommand
          invoke  SetFocus, hWnd04
        .elseif eax == 313              ; Fourth Radio Button
          mov     hResult, 313          ; MODE = Just get the length of the string
          invoke  SendMessage, hWnd06, EM_SETREADONLY, FALSE, 0
          invoke  SendMessage, hWnd04, EM_SETREADONLY, TRUE, 0
          invoke  SendMessage, hWnd05, EM_SETREADONLY, TRUE, 0
          invoke  CopyCat, addr szDest,
                  chr$("The length of the text in this box will be shown below when you click the 'Show Result' Button."), NULL
          invoke  SendMessage, hWnd06, WM_SETTEXT, 0, addr szDest

          invoke  CopyCat, addr szCommand,
                  chr$("invoke  CopyCat, addr szResult, NULL, NULL"), NULL
          invoke  SendMessage, hWnd16, WM_SETTEXT, 0, addr szCommand
          invoke  SetFocus, hWnd06
        .endif
      .endif
    .elseif uMsg==WM_DESTROY
      invoke  DestroyIcon, hIcon
      invoke  DeleteObject, hFont1
      invoke  DeleteObject, hFont2
      invoke  PostQuitMessage, NULL
    .else
      invoke  DefWindowProc, hWnd, uMsg, wParam, lParam
      ret
    .endif
    xor    eax, eax
    ret
;---------------------------------------
WndProc endp

MakeButton proc  lpText:DWORD, hParent:DWORD, a:DWORD, b:DWORD, wd:DWORD, ht:DWORD, ID:DWORD
;---------------------------------------
    szText  ButtonClass, "BUTTON"
    invoke  CreateWindowEx, 0, addr ButtonClass, lpText, WS_CHILD or WS_VISIBLE \
            or BS_PUSHBUTTON, a, b, wd, ht, hParent, ID, hInstance, NULL
    ret
;---------------------------------------
MakeButton endp

MakeCheckBox proc  lpText:DWORD, hParent:DWORD, a:DWORD, b:DWORD, wd:DWORD, ht:DWORD, ID:DWORD
;---------------------------------------
    invoke  CreateWindowEx, 0, addr ButtonClass, lpText, WS_CHILD or WS_VISIBLE \
            or BS_AUTORADIOBUTTON, a, b, wd, ht, hParent, ID, hInstance, NULL
    ret
;---------------------------------------
MakeCheckBox endp

MakeBox proc  lpText:DWORD, hParent:DWORD, a:DWORD, b:DWORD, wd:DWORD, ht:DWORD, ID:DWORD
;---------------------------------------
    szText  ContClass, "STATIC"
    invoke  CreateWindowEx, 0, addr ContClass, lpText, WS_CHILD or WS_VISIBLE or \
            SS_LEFT or SS_CENTERIMAGE, a, b, wd, ht, hParent, ID, hInstance, NULL
    ret
;---------------------------------------
MakeBox endp

MakeBar proc  lpText:DWORD, hParent:DWORD, a:DWORD, b:DWORD, wd:DWORD, ht:DWORD, ID:DWORD
;---------------------------------------
    szText  BarClass, "STATIC"
    invoke  CreateWindowEx, 0, addr BarClass, lpText, WS_CHILD or WS_VISIBLE or \
            SS_BLACKRECT, a, b, wd, ht, hParent, ID, hInstance, NULL
    ret
;---------------------------------------
MakeBar endp

MakeEditBox proc  lpText:DWORD, hParent:DWORD, a:DWORD, b:DWORD, wd:DWORD, ht:DWORD, ID:DWORD
;---------------------------------------
    szText  EditClass, "EDIT"
    invoke  CreateWindowEx, 0, addr EditClass, lpText, WS_CHILD or \
            WS_VISIBLE or WS_BORDER or ES_AUTOHSCROLL or SS_LEFT,
            a, b, wd, ht, hParent, ID, hInstance, NULL
    ret
;---------------------------------------
MakeEditBox endp

MakeFrame proc  lpText:DWORD, hParent:DWORD, a:DWORD, b:DWORD, wd:DWORD, ht:DWORD, ID:DWORD
;---------------------------------------
    invoke  CreateWindowEx, 0, addr BarClass, lpText, WS_CHILD or \
            WS_VISIBLE or WS_BORDER,
            a, b, wd, ht, hParent, ID, hInstance, NULL
    ret
;---------------------------------------
MakeFrame endp

;-------------------------------------------------------------;
; Because lstrcpy, lstrcat and lstrlen do not preserve some   ;
; registers, I took an already existing version of CopyCat    ;
; and designed it to do all three. The length of the result   ;
; is always returned in EAX no matter what mode you choose    ;
; to use so lstrlen is taken care of inherently.              ;
;                                                             ;
; USAGE: The four modes are determined by the values passed   ;
;        in the last two pointers.                            ;
;     1. If Source1 is NULL, Source2 is concatenated to Dest. ;
;     2. If Source2 is NULL, Source1 is copied to Dest.       ;
;     3. If both are NULL, the length of Dest is returned.    ;
;     4. If neither are NULL, Source1 is copied to Dest and   ;
;        then Source2 is concatenated to it.                  ;
;-------------------------------------------------------------;
CopyCat proc Dest, Source1, Source2
;---------------------------------------
    push    esi
    push    edi
    push    ecx
    xor     ecx, ecx                    ; Clear the character counter
    mov     edi, Dest                   ; Point to the string to store results in
    cmp     byte ptr Source1, 0         ; Copy?
    jne     @f                          ; If yes, go do it
ca2:cmp     byte ptr [edi], 0           ; Move to the end of the existing string, first
    je      cat                         ; ... and then go add to it
    inc     edi                         ; Update the buffer pointer
    inc     ecx                         ; Count the character
    jmp     ca2                         ; Continue searching and counting
@@: mov     esi, Source1                ; Point to the string to copy from
@@: mov     al, [esi]                   ; Get character to copy
    mov     [edi], al                   ; Copy it
    inc     esi                         ; Update the buffer pointer
    inc     edi                         ; Update the buffer pointer
    inc     ecx                         ; Count the character
    cmp     byte ptr [esi], 0           ; EOS
    jnz     @b                          ; Continue until done
    mov     byte ptr [edi], 0           ; ASCIIZ terminator (just in case Dest was dirty
cat:cmp     byte ptr Source2, 0         ; Just a copy or length request?
    je      done                        ; Done, if just getting the length of Dest
    mov     esi, Source2                ; Point to the string to concatenate from
@@: mov     al, [esi]                   ; Get character to concatenate
    mov     [edi], al                   ; Concatenate it
    inc     esi                         ; Update the buffer pointer
    inc     edi                         ; Update the buffer pointer
    inc     ecx                         ; Count the character
    cmp     byte ptr [esi], 0           ; EOS?
    jnz     @b                          ; Continue until done
    mov     byte ptr [edi], 0           ; ASCIIZ terminator (just in case Dest was dirty
done:
    mov     eax, ecx                    ; Get the character count
    pop     ecx
    pop     edi
    pop     esi
    ret
;---------------------------------------
CopyCat endp

; Converts a 32 bit number value into an
; ASCII string (and terminates it).
;---------------------------------------
BaseToAscii   proc InPut:DWORD, OutPut, Fill
;---------------------------------------
        mov     eax, InPut
        mov     edi, OutPut
        .if eax < 10 && Fill
          mov     byte ptr [edi], '0'
          inc     edi
        .endif
        mov     esi, edi
        mov     ecx, 10
        .while (eax > 0)
          xor     edx, edx
          div     ecx                   ; Put next digit in edx
          add     dl, '0'               ; Convert to ASCII
          mov     [edi], dl             ; Store it
          inc     edi
        .endw
        mov     byte ptr [edi], 0       ; Terminate the string
        .while (esi < edi)
          dec     edi
          mov     al, [esi]
          mov     ah, [edi]
          mov     [edi], al
          mov     [esi], ah
          inc     esi
        .endw
        ret
;---------------------------------------
BaseToAscii   endp

    end     start

;   Used for my tests. It can be safely deleted if you have another way
    pushad
    invoke  dwtoa, Row, addr ShowString
    invoke  MessageBox, NULL, addr ShowString, chr$("Testing"), MB_OK
    invoke  dwtoa, Column, addr ShowString
    invoke  MessageBox, NULL, addr ShowString, chr$("Testing"), MB_OK
    invoke  dwtoa, Grid, addr ShowString
    invoke  MessageBox, NULL, addr ShowString, chr$("Testing"), MB_OK
    popad
